#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll nzs(ll c, ll d)
{
    if(c==0)
    {
        return d;
    }
    return nzs(d%c, c);
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	ll n, m;
	cin >> t;
	while(t--)
    {
        cin >> n >> m;
        vector<ll> a(n);
        vector<ll> b(m);
        vector<ll> r;
        bool res=true;
        for(ll i=0; i<n; i++)
        {
            cin >> a[i];
        }
        for(ll i=0; i<m; i++)
        {
            cin >> b[i];
        }
        sort(a.begin(),a.end());
        sort(b.begin(),b.end());
        for(ll i=1; i<n; i++)
        {
            r.push_back(a[i]-a[i-1]);
        }
        ll nz=r[0];
        for(ll i=1; i<r.size(); i++)
        {
            nz=nzs(nz, r[i]);
            if(nz==1)
            {
                break;
            }
        }
        for(ll i=0; i<b.size(); i++)
        {
            if((b[i]-a[0])%nz==0)
            {
                res=false;
            }
        }
        if(res)
        {
            cout << 1 << "\n";
        }
        else
        {
            cout << 0 << "\n";
        }
    }
}